//---------------------------------------------------------------------------

#include <vcl.h>
#include <SyncObjs.hpp>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
TEvent *tev;//    1
TEvent *tev2;//    2

//----------- --------------
__fastcall HThr::HThr(bool CreateSuspended, TMemo * memo, TEvent *TEV)
	: TThread(CreateSuspended)
{
 Memo = memo;
 ttt = TEV;
}

//-----------  --------------
void __fastcall HThr::Execute()
{
int count = 0;
 while(!Terminated)
 {
  count++;
  Memo->Lines->Add(" wait -");
  ttt->WaitFor(INFINITE);
  Memo->Lines->Add(" wait -\r\n");
  Memo->Text =  Memo->Text + count;
  Sleep(1000);
  if(Memo->Lines->Count > 12)
    Memo->Clear();
 }
}

//--------------  1  ------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
 tev->SetEvent();
}
//---------------------------------------------------------------------------
//--------------  1  ------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
tev->ResetEvent();
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//-----------  -     -------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
 tev = new TEvent(NULL, true, false, "TTT1");//   TTT1 -    
 tev2 = new TEvent(NULL, true, false, "TTT2");//   
 Thr = new HThr(true,Form1->Memo1,tev);
 Thr2 = new HThr(true,Form1->Memo2,tev2);
 Thr->Priority =  tpLower;
 Thr2->Priority = tpLower;
}
//---------------------------------------------------------------------------
//----------- --------------
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
 delete tev;
 //  
 delete Thr;
 delete Thr2;
}
//---------------------------------------------------------------------------
//-------------- ------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{
 Thr->Resume();
 Thr2->Resume();
}
//---------------------------------------------------------------------------
//--------------  2  ------------
void __fastcall TForm1::Button4Click(TObject *Sender)
{
tev2->SetEvent();
}
//---------------------------------------------------------------------------
//--------------  2  ------------
void __fastcall TForm1::Button5Click(TObject *Sender)
{
tev2->ResetEvent();
}
//---------------------------------------------------------------------------

